import wx
from ctypes import cdll
from ctypes import *
import os
import interface
import sys
import pickle


class objektUlaz(Structure):
	_fields_ = [("sirina", c_int),
		("dubina", c_int),
		("kolicina", c_int)]

class objektIzlaz(Structure):
	_fields_ = [("sloj_id", c_int),
		("sloj_dubina", c_int),
		("sirina", c_int),
		("dubina", c_int),
		("x", c_int), 
		("y", c_int)]

class pocetniUvjeti(Structure):
	_fields_ = [("rotacija", c_int),
		("umetanje", c_int),
		("sirina", c_int),
		("duljina", c_int),
		("brojObjekata", c_int),
		("brojSlojeva", c_int),
		("brojKoraka", c_int),
		("brojJedinki", c_int),
		("krizanje", c_int),
		("mutacija", c_int)]


class objekt:
	def __init__(self, id, s, d, x, y):
		self.id = id
		self.sirina = s
		self.dubina = d
		self.x = x
		self.y = y

class sloj:
	def __init__(self, id, sirina, dubina):
		self.objekti = []
		self.dubina = dubina
		self.sirina = sirina
		self.id = id;
		
	def dodajObjekt(self, objekt):		
		self.objekti.append(objekt)
		

class spremanje:
	def __init__(self, obj, sirina, brGen, brEvo, brKri, brMut):
		self.sirina = sirina
		self.brGen = brGen
		self.brEvo = brEvo
		self.objekti = obj
		self.brKri = brKri
		self.brMut = brMut
	


id = 0
def newId():
	global id
	id += 1	
	return str(id)

class Interface(interface.GA):
	def __init__(self, *args, **kwds):
		interface.GA.__init__(self, *args, **kwds)
		self.pripremi()		
		
	def pripremi(self):
		self.mydll = cdll.LoadLibrary('/home/pofuk/Desktop/kodovi/algoritam.so')
		
	        self.panelPocetna.Bind(wx.EVT_PAINT, self.on_paint_poc)	
	        self.panelKonacna.Bind(wx.EVT_PAINT, self.on_paint_kon)	
		self.sliderPozicija.Bind(wx.EVT_COMMAND_SCROLL, self.on_scroll)		


		self.listCtrlPregledUnesenih.InsertColumn(1, "ID", width = 30)
		self.listCtrlPregledUnesenih.InsertColumn(2, "Visina", width = 60)
		self.listCtrlPregledUnesenih.InsertColumn(3, "Dubina", width = 60)
		self.listCtrlPregledUnesenih.InsertColumn(4, "Kolicina", width = 60)

		self.buttonDodaj.Bind(wx.EVT_BUTTON, self.onDodajButton);
	
		self.slojeviPoc = []
		self.slojeviKon = []

		self.objektiUlaz = []
		self.uvjeti = pocetniUvjeti();

		self.buttonSpremi.Bind(wx.EVT_BUTTON, self.onSpremiButton);
		self.buttonOtvori.Bind(wx.EVT_BUTTON, self.onOtvoriButton);
		self.buttonPokreni.Bind(wx.EVT_BUTTON, self.onPokreniButton);
		self.buttonNastavi.Bind(wx.EVT_BUTTON, self.onNastaviButton);

		self.setTabIndexes()

	def setTabIndexes(self):	
		self.textCtrlSirina.Bind(wx.EVT_TEXT_ENTER, self.onTabTextCtrlSirina)		
		self.textCtrlDubina.Bind(wx.EVT_TEXT_ENTER, self.onTabTextCtrlDubina)
		self.textCtrlKolicina.Bind(wx.EVT_TEXT_ENTER, self.onTabTextCtrlKolicina)
		
		self.textCtrlSirina.SetFocus();	

	def onTabTextCtrlSirina(self, event):
		self.textCtrlDubina.SetFocus()

	def onTabTextCtrlDubina(self, event):
		self.textCtrlKolicina.SetFocus()
	
	def onTabTextCtrlKolicina(self, event):
		self.buttonDodaj.SetFocus()
	
	def on_paint_poc(self, event):
		self.nacrtaj(self.panelPocetna, self.slojeviPoc)

	def on_paint_kon(self, event):
		self.nacrtaj(self.panelKonacna, self.slojeviKon)

	def on_scroll(self, event):
		self.nacrtaj(self.panelPocetna, self.slojeviPoc)
		self.nacrtaj(self.panelKonacna, self.slojeviKon)

	def onDodajButton(self, event):
		sirina = self.textCtrlSirina.GetValue()
		dubina = self.textCtrlDubina.GetValue()
		kolicina = self.textCtrlKolicina.GetValue()

		self.textCtrlSirina.SetFocus();

		if sirina == "" or dubina == "" or kolicina == "":
			return 

		self.textCtrlSirina.Clear()
		self.textCtrlDubina.Clear()
		self.textCtrlKolicina.Clear()

		self.objektiUlaz.append(objektUlaz(int(sirina), int(dubina), int(kolicina)))
		self.dodajListi(sirina, dubina, kolicina)



	def dodajListi(self, sirina, dubina, kolicina):
		newItem = self.listCtrlPregledUnesenih.InsertStringItem(sys.maxint, newId())

		self.listCtrlPregledUnesenih.SetStringItem(newItem, 1, sirina)
		self.listCtrlPregledUnesenih.SetStringItem(newItem, 2, dubina)
		self.listCtrlPregledUnesenih.SetStringItem(newItem, 3, kolicina)
			


	def onSpremiButton(self, event):
		dlg = wx.FileDialog(self, "Choose a file", style = wx.FD_SAVE)
		if dlg.ShowModal() == wx.ID_OK:
			f = open(dlg.GetPath(), "w")
			sirina = self.textCtrlSirinaKontejnera.GetValue()
			brGen = self.textCtrlGeneracija.GetValue()
			brEvo = self.textCtrlEvolucija.GetValue()
			brKri = self.textCtrlKrizanje.GetValue()
			brMut = self.textCtrlMutacija.GetValue()
			spr = spremanje(self.objektiUlaz, sirina, brGen, brEvo, brKri, brMut)
			pickle.dump(spr, f);
		
		dlg.Destroy()

	def onOtvoriButton(self, event):
		dlg = wx.FileDialog(self, message="Choose a file")
 
	        if dlg.ShowModal() == wx.ID_OK:
			filename = dlg.GetPath()
			self.procitajPodatke(filename)

		dlg.Destroy()
				
		
		
	def onPokreniButton(self, event):
		self.brojObjekata = c_int(len(self.objektiUlaz))
		if self.brojObjekata == 0:
			return 
	
	        self.ulazni = (objektUlaz*self.brojObjekata.value)();
		for i in range(0, self.brojObjekata.value):	
			self.ulazni[i] = objektUlaz(int(self.objektiUlaz[i].sirina), int(self.objektiUlaz[i].dubina), int(self.objektiUlaz[i].kolicina))

		self.brojIzlazanihObjekata = 0
		for i in self.objektiUlaz:
			self.brojIzlazanihObjekata += int(i.kolicina)
		print self.brojIzlazanihObjekata
		self.izlazni = (objektIzlaz*self.brojIzlazanihObjekata)();
			
		self.pripremiUvijete()
	
		self.mydll.pokreni(byref(self.ulazni), byref(self.izlazni), byref(self.uvjeti))

		self.slojeviPoc = []
		self.pripremiObjekte(self.slojeviPoc)

		self.pocTextCtrlBrojSlojeva.SetValue(str(self.uvjeti.brojSlojeva))
		self.pocTextCtrlDuljina.SetValue(str(self.uvjeti.duljina))

		self.nacrtaj(self.panelPocetna, self.slojeviPoc)
	
	def onNastaviButton(self, event):
		self.izlazni = (objektIzlaz*self.brojIzlazanihObjekata)();
		self.mydll.sljedeciKorak(byref(self.izlazni))
		self.slojeviKon = []
		self.pripremiObjekte(self.slojeviKon)

		self.konTextCtrlBrojSlojeva.SetValue(str(self.uvjeti.brojSlojeva))
		self.konTextCtrlDuljina.SetValue(str(self.uvjeti.duljina))

		self.nacrtaj(self.panelKonacna, self.slojeviKon)
		
	def pripremiUvijete(self):
		if self.checkBoxRotacija.GetValue():
			self.uvjeti.rotacija = 1;
		else:
			self.uvjeti.rotacija = 0;

		
		if self.checkBoxUmetanje.GetValue():
			self.uvjeti.umetanje = 1;
		else:
			self.uvjeti.umetanje = 0;

		self.uvjeti.sirina = int(self.textCtrlSirinaKontejnera.GetValue())
		self.uvjeti.duljina = 0
		self.uvjeti.brojObjekata = self.brojObjekata
		self.uvjeti.brojSlojeva = 0;
		self.uvjeti.brojKoraka = int(self.textCtrlGeneracija.GetValue());
		self.uvjeti.brojJedinki = int(self.textCtrlEvolucija.GetValue());
		self.uvjeti.krizanje = int(self.textCtrlKrizanje.GetValue());
		self.uvjeti.mutacija = int(self.textCtrlMutacija.GetValue());


	def pripremiObjekte(self, lista):
		dodani = False

		
		for i in range(0, self.uvjeti.brojObjekata):
			#print self.uvjeti.brojSlojeva, self.izlazni[i].sloj_id;
			obj = objekt(self.izlazni[i].sloj_id, self.izlazni[i].dubina, self.izlazni[i].sirina, self.izlazni[i].x, self.izlazni[i].y)
			for sl in lista: 
				if sl.id == self.izlazni[i].sloj_id:
					sl.dodajObjekt(obj)
					dodani = True
					break
			if not dodani:				
				novi = sloj(self.izlazni[i].sloj_id, self.uvjeti.sirina, self.izlazni[i].sloj_dubina)
				novi.dodajObjekt(obj)
				lista.append(novi)
			#print obj.id
			dodani = False

		#self.slojeviPoc.reverse()	
		
	
					
	
	def procitajPodatke(self, path):
		f = open(path)
		load = pickle.load(f);		
		f.close()

		self.objektiUlaz = load.objekti
		self.textCtrlSirinaKontejnera.SetValue(str(load.sirina))
		self.textCtrlGeneracija.SetValue(str(load.brGen))
		self.textCtrlEvolucija.SetValue(str(load.brEvo))
		self.textCtrlKrizanje.SetValue(str(load.brKri))
		self.textCtrlMutacija.SetValue(str(load.brMut))

		for i in self.objektiUlaz:
			self.dodajListi(str(i.sirina), str(i.dubina), str(i.kolicina))
	
		
	def nacrtaj(self, panel, slojevi):
		dc = wx.PaintDC(panel)

		x = 2.5;
		dc.SetBrush(wx.Brush(wx.Colour(200, 200, 200)))
		dc.SetPen(wx.Pen(wx.Colour(200, 200, 200), 1))
		dc.DrawRectangle(0, 0, 1000, 200)	

		trenutnaPozicija = self.sliderPozicija.GetValue()
		ukupnaDuljina = 0;

		for i in slojevi:
			ukupnaDuljina += i.dubina

		pozicija = float(ukupnaDuljina) /100 * trenutnaPozicija + 2.5

		dc.SetPen(wx.Pen('black', 1))
		dc.DrawRectangle(4, 5, ukupnaDuljina *2  - pozicija*2 + 1, self.uvjeti.sirina * 2);		
		dc.SetBrush(wx.WHITE_BRUSH)

		#print 
		
		for i in slojevi:
			#print "Id sloja: ", i.id
			for j in i.objekti:
				#print "   ", j.x*2 , j.y*2 , j.sirina*2, j.dubina*2
		        	dc.DrawRectangle((x + j.x)*2 - pozicija*2,  5 + (j.y)*2 , j.sirina*2, j.dubina*2)	
			x += i.dubina

		
		dc.DrawLine(4, 5, 4, 160)
		
		dc.SetBrush(wx.Brush(wx.Colour(200, 200, 200)))
		dc.SetPen(wx.Pen(wx.Colour(200, 200, 200), 1))
		dc.DrawRectangle(0,0, 4, 200);


		# draw a blue line (thickness = 2)
		#
		#dc.DrawLine(50, 20, 300, 20)

		#dc.SetPen(wx.Pen('red', 1))
        	# draw a red rounded-rectangle
		#rect = wx.Rect(50, 50, 100, 100) 
        	#dc.DrawRoundedRectangleRect(rect, 8)
        	# draw a red circle with yellow fill
        	#dc.SetBrush(wx.Brush('yellow'))
        	#x = 200
        	#y = 100
        	#r = 50
        	#dc.DrawCircle(x, y, r)
		

#

if __name__ == "__main__":
    app = wx.App()
    frame_1 = Interface(None, -1, "")
    frame_1.Show()
    app.MainLoop()
