#include <list>
#include <stdio.h>
#include "objekt.h"
#include "sloj.h"
#include "raspored.h"


//C+ -Wall -Wextra -O -ansi -pedantic -shared algoritamDLL.cpp -o algoritam.so
using namespace std;




class pretrazivanje {
  public:	
	pretrazivanje(pocetniUvjeti *uvj);
	void zapocniPretrazivanje(objektUlaz *ulaz, objektIzlaz *izlaz);

	void nastaviPretrazivanje(objektIzlaz *izlaz);
  private:
	list<raspored> *rasporedi;
	list<objekt> objekti;
	pocetniUvjeti *uvjeti;
	
	bool usporedba(const objekt *prvi, const objekt *drugi);
	void smjesti(objekt *);
	void stvoriGeneraciju();

	void krizanje(raspored &novi, raspored &prvi, raspored &drugi);
	void mutacija(raspored &novi, raspored &prvi);
	raspored odaberiSlucajnog(int granica);
	};

pretrazivanje::pretrazivanje(pocetniUvjeti *uvj) {
	uvjeti = uvj;
	}


int minDuljina = 0;
raspored *minRaspored;

void pretrazivanje::zapocniPretrazivanje(objektUlaz *ulaz, objektIzlaz *izlaz){
	int id = 0;
	int brojIzlaza = 0;
	for (int i = 0; i< uvjeti->brojObjekata; i++) {	
		for (int j = 0; j<ulaz[i].kolicina; j++) {	
			brojIzlaza ++;
			objekt *objektNovi = new objekt(id++, i, 0, 0, 0, ulaz[i].sirina, ulaz[i].dubina);
			objekti.push_front(*objektNovi);
			}
		}
	objekti.sort();
	rasporedi = new list<raspored>();
	raspored *rasp = new raspored(uvjeti);

	rasporedi->push_front(*rasp);
	this->uvjeti->brojObjekata = brojIzlaza;

	//printf("broj izlaza: %d\n", brojIzlaza);

	list<raspored>::iterator prviRaspored = rasporedi->begin();
	for (list<objekt>::iterator it = objekti.begin(); it!=objekti.end(); it++) {	
		prviRaspored->dodajObjekt(&(*it));
		}
	
	prviRaspored->napuni();
	minDuljina = prviRaspored->duljina;
	minRaspored = new raspored(*prviRaspored);	
	prviRaspored->dumpajRaspored(izlaz, uvjeti);

	for (int i = 0; i<uvjeti->brojJedinki -2; i++)
		rasporedi->push_front(*prviRaspored);
	
	
		
    	}

bool operator<(const raspored &prvi, const raspored &drugi) {
	if (prvi.duljina < drugi.duljina)
		return true;
	return false;
	}

void pretrazivanje::nastaviPretrazivanje(objektIzlaz *izlaz) {
	//list<raspored> *stari = NULL;

	for (int i=0; i<uvjeti->brojKoraka; i++) {
		//printf("brg: %d \n", i);
		stvoriGeneraciju();
		rasporedi->sort();
		list<raspored>::iterator prviRaspored = rasporedi->begin();
		//printf("%d %d \n", prviRaspored->duljina,  minDuljina);
		if (prviRaspored->duljina < minDuljina) {
			delete minRaspored;
			minDuljina = prviRaspored->duljina;
			minRaspored = new raspored(*prviRaspored);
			}
		else {
			
			}
		}
	
	//printf("da\n");
	minRaspored->dumpajRaspored(izlaz, uvjeti);
	}

void pretrazivanje::stvoriGeneraciju(){
	list<raspored> *noviRasporedi = new list<raspored>();
	for (int i = 0; i<uvjeti->brojJedinki; i++) {
		raspored novi = raspored(uvjeti);

		raspored prvi = odaberiSlucajnog(rasporedi->size() /4);
		//printf("1\n");
		raspored drugi = odaberiSlucajnog(rasporedi->size());
		int k = 0;
		//printf("2\n");
		for (list<objekt>::iterator it = objekti.begin(); it != objekti.end(); it++) {
			//printf(" %d\n", k);
			k++;
			novi.dodajObjekt(&(*it));
			}
		//printf("3\n");
		srand(time(NULL));
		int vjer = (rand() %100) +1;
		if (vjer < uvjeti->krizanje)
			krizanje(novi, prvi, drugi);
		//printf("4\n");
		else if (vjer > uvjeti->krizanje)
			mutacija(novi, prvi);		

		novi.napuni();
		noviRasporedi->push_front(novi);
		}	
	delete rasporedi;
	rasporedi = noviRasporedi;
			
	
	}

raspored pretrazivanje::odaberiSlucajnog(int granica) {
	int broj = rand() % granica;
	list<raspored>::iterator it = rasporedi->begin();
	for (int i = 0; i<broj; i++)
		it++;
	return (*it);
	}

void pretrazivanje::krizanje(raspored &novi, raspored &prvi, raspored &drugi) {
	int j = -1;
	for (list<sloj>::iterator it = prvi.slojevi.begin(); it != prvi.slojevi.end() && j<(int)prvi.slojevi.size()/4; it++) {
		j++;
		bool dodani = novi.dodajSloj(*it);
		if (!dodani) {
			break;
			}
		}
	for (list<sloj>::iterator it = drugi.slojevi.begin(); it != drugi.slojevi.end() && j<(int)prvi.slojevi.size()/4; it++) {
		printf("k2\n");
		j++;
		bool dodani = novi.dodajSloj(*it);
		if (!dodani)
			break;
		}
	}

void pretrazivanje::mutacija(raspored &novi, raspored &prvi) {
	//printf("z1 %d\n", rand());
	int j = (rand()) % (prvi.slojevi.size()/2 + 1) +1;
	//printf("z2 %d\n", j);
	for (list<sloj>::iterator it = prvi.slojevi.begin(); j>0; it++, j--) {
		//printf("m1\n");
		novi.dodajSloj(*it);
		}
	}


