using namespace std;

class raspored {      
  public:
	raspored(pocetniUvjeti *);

	list<sloj> slojevi;

	void dodajObjekt(objekt *);
	void napuniBHFD();
	void dumpajRaspored(objektIzlaz *, pocetniUvjeti *);
	void napuni();

	bool dodajSloj(sloj );
	int duljina;


  private:
	int slojId;
	pocetniUvjeti uvjeti;
	list<objekt> slobodni;    
	
	objekt * odaberiSlucajan(list<objekt> *lista);  
	bool daliPostoji(list<objekt> * lista, objekt ulaz);
	};

raspored::raspored(pocetniUvjeti *uvj) {
	uvjeti.rotacija = uvj->rotacija;
	uvjeti.umetanje = uvj->umetanje;
	uvjeti.sirina = uvj->sirina;
	uvjeti.duljina = uvj->duljina;
	duljina = 0;
	uvjeti.brojObjekata = uvj->brojObjekata;
	uvjeti.brojSlojeva = uvj->brojSlojeva;
	slojId = 0;
	}


void raspored::dodajObjekt(objekt *ulaz) {
	slobodni.push_front(*ulaz);
	}

bool raspored::dodajSloj(sloj ulaz) {
	bool moguSvi = true;
	//printf("1 %d\n", ulaz.slobodni.size());
	for (list<objekt>::iterator it = ulaz.objekti.begin(); it!=ulaz.objekti.end() && moguSvi; it++) {
		moguSvi = daliPostoji(&this->slobodni, *it);
		}
	//printf("2\n");
	if (moguSvi) {
		ulaz.redniBroj = ++slojId;
		this->slojevi.push_front(ulaz);
		for (list<objekt>::iterator it = ulaz.objekti.begin(); it!=ulaz.objekti.end(); it++) {
			slobodni.remove(*it);
			}
		this->duljina += ulaz.dubina;
		}
	//printf("3\n");
	this->slojevi.sort();
	return moguSvi;
	}

bool raspored::daliPostoji(list<objekt> * lista, objekt ulaz) {
	bool postoji = false;
	list<objekt>::iterator it = lista->begin();
	for (;it!=lista->end() && !postoji; it++) {
		if ((*it).id == ulaz.id)
			postoji = true;
		}
	return postoji;
	}
bool operator==(const objekt &prvi, const objekt &drugi) {
	if ((prvi.id == drugi.id))
		return true;
	return false;
	}

void raspored::napuni()  {
	bool dodani = false;
	while (this->slobodni.size()) {
		objekt *slucajni = odaberiSlucajan(&slobodni);
		if (this->slojevi.size()) {
			list<sloj>::iterator it = slojevi.end();
			it--;

			dodani = (*it).dodajObjekt(slucajni);
			}
	if (!dodani) {
			sloj *noviSloj = new sloj(slucajni, &uvjeti, ++slojId);
			slojevi.push_back(*noviSloj);
			this->duljina += noviSloj->dubina;
			}
		slojevi.sort();
		slobodni.remove(*slucajni);
		dodani = false;
		}
	}

void raspored::napuniBHFD() {
	for (list<objekt>::iterator it = slobodni.begin(); it!=slobodni.end(); it++) {	
		objekt *ulaz = &(*it);
		bool dodani = false;
		for (list<sloj>::iterator it = slojevi.begin(); it != slojevi.end() && !dodani; it++) {	
			dodani = (*it).dodajObjekt(ulaz);
			}
			if (!dodani) {
			//printf("02\n");	
			sloj *noviSloj = new sloj(ulaz, &uvjeti, slojId++);		
			slojevi.push_front(*noviSloj);
			dodani = noviSloj->dodajObjekt(ulaz);		
			}
		slojevi.sort();
		//printf("03\n");	
		}
	}

void raspored::dumpajRaspored(objektIzlaz *izlaz, pocetniUvjeti *uvjeti) {
	int bo = 0;
	uvjeti->duljina = 0;
	for (list<sloj>::iterator it = this->slojevi.begin(); it != this->slojevi.end(); it++) {
		bo += (*it).dumpajSloj(&izlaz[bo]);		
		}
	uvjeti->duljina = (int)duljina;
	uvjeti->brojSlojeva = (int)slojevi.size();
	}


objekt * raspored::odaberiSlucajan(list<objekt> *lista) {
	int broj = rand() % (lista->size());
	list<objekt>::iterator it = lista->begin();
	for (int i = 0; i<broj; i++)
		it++;	
	return &(*it);
	}
