
using namespace std;

class slobodniProstor {
   public:
	int sirina;
	int dubina;
	int x;
	int y;	

	slobodniProstor(int, int, int, int);
	bool daliStane(objekt *ulaz, int rotacija);
	bool dodajObjekt(objekt *, int , int, slobodniProstor **, slobodniProstor **);
   private:
	void umetniNovi(int, int, int, slobodniProstor **, slobodniProstor **);
	};

slobodniProstor::slobodniProstor(int sirina, int dubina, int x, int y) {
	this->sirina = sirina;
	this->dubina = dubina;
	this->x = x;
	this->y = y;
	}

bool slobodniProstor::daliStane(objekt *ulaz, int rotacija) {
	int sirina = ulaz->sirina;
	int dubina = ulaz->dubina; 
	//printf ("		kon: %d %d %d %d\n", ulaz->sirina, ulaz->dubina, this->sirina, this->dubina);
	if ((sirina <= this->sirina)&&(dubina <= this->dubina)) {
		//printf("c1\n");
		return true;
		}

	if (rotacija){
		int sir =sirina;
		sirina = dubina;
		dubina = sir;
		}

	if ((sirina <= this->sirina)&&(dubina <= this->dubina)) {
		//printf("c2\n");
		return true;
		}
	return false;
	}

bool slobodniProstor::dodajObjekt(objekt *ulaz, int rotacija, int umetanje, slobodniProstor **prvi, slobodniProstor **drugi) {
	ulaz->x = this->x;
	ulaz->y = this->y;		
	if ((ulaz->sirina <= this->sirina)&&(ulaz->dubina <= this->dubina)) {
		umetniNovi(ulaz->sirina, ulaz->dubina, umetanje, prvi, drugi);	
		//printf("u1\n");
		return true;
		}
	if (rotacija){
		int sir = ulaz->sirina;
		ulaz->sirina = ulaz->dubina;
		ulaz->dubina = sir;
		ulaz->orjentacija = 1;
		}

	if ((ulaz->sirina <= this->sirina)&&(ulaz->dubina <= this->dubina)) {
		//printf("u2\n");
		umetniNovi(ulaz->sirina, ulaz->dubina, umetanje, prvi, drugi);	
		return true;
		}

	return false;
	}


void slobodniProstor::umetniNovi(int sirina, int dubina, int umetanje, slobodniProstor **prvi, slobodniProstor **drugi) {
	if (umetanje) {
		if (this->dubina - dubina)
			*prvi = new slobodniProstor(sirina, this->dubina - dubina, this->x + dubina, this->y);
		if (this->sirina - sirina)
			*drugi  = new slobodniProstor(this->sirina - sirina, this->dubina, this->x, this->y + sirina);
		
		}
	else {
		if (this->dubina - dubina)
			*prvi = new slobodniProstor(this->sirina , this->dubina-dubina, this->x + dubina, this->y);
		if (this->sirina - sirina)
			*drugi  = new slobodniProstor(this->sirina - sirina, dubina, this->x, this->y + sirina);
		}
	}
	
class sloj {
  public:
	float mjera_ispunjavanja;
	int broj_objekata;            

	sloj(objekt*, pocetniUvjeti *, int redniBroj);

	bool dodajObjekt(objekt *);
	int dumpajSloj(objektIzlaz *prazni);
	int dubina;

	list<objekt> objekti;
	list<slobodniProstor> slobodni;
	int redniBroj;
  private:        
	
	pocetniUvjeti *uvjeti;


	bool usporedba(sloj, sloj);

	};

bool operator<(const objekt &prvi, const  objekt &drugi) {
     if (drugi.dubina < prvi.dubina)
		 return true;
	 return false;        
     }

sloj::sloj(objekt *glavni_objekt, pocetniUvjeti *uvj, int redniBroj) {
	this->uvjeti = uvj;	
	this->redniBroj = redniBroj;
	this->dubina = glavni_objekt->dubina;
	
	objekti.push_front(*glavni_objekt);
	slobodniProstor *slb = new slobodniProstor(uvj->sirina - glavni_objekt->sirina, glavni_objekt->dubina, 0 , glavni_objekt->sirina);
	slobodni.push_front(*slb);
	this->mjera_ispunjavanja = (float)glavni_objekt->sirina/ uvj->sirina;
	//printf("mi %d %d %d %f\n", this->dubina, uvj->sirina, redniBroj, this->mjera_ispunjavanja);
	}

int sloj::dumpajSloj(objektIzlaz *prazni) {	
	int bs = 0;
	for (list<objekt>::iterator it = objekti.begin(); it != objekti.end(); it++) {
		prazni->sloj_id = this->redniBroj;
		prazni->sloj_dubina = this->dubina;
		
		prazni->sirina = (*it).sirina;
		prazni->dubina = (*it).dubina;
		prazni->x = (*it).x;
		prazni->y = (*it).y;
		
		prazni++;
		bs++;		
		}

	return bs;
	}


bool operator<(sloj &prvi, sloj &drugi) {
     if (prvi.mjera_ispunjavanja > drugi.mjera_ispunjavanja)
		 return true;
	 return false;        
     }

bool sloj::dodajObjekt(objekt * obj) {
	bool kraj = false;


	//printf("brSloja: %d %d\n", this->redniBroj, slobodni.size());
	list<slobodniProstor>::iterator	it  = slobodni.begin();
	for (;it != slobodni.end() && !kraj; it++) {
		kraj = it->daliStane(obj, uvjeti->rotacija);
		//printf ("	svi: %d %d %d %d \n", it->x, it->y, it->sirina, it->dubina);
		}
	it--;
	if (kraj) {
		slobodniProstor *prvi = NULL, *drugi = NULL; 
		//printf("001\n");
		it->dodajObjekt(obj, uvjeti->rotacija, uvjeti->umetanje, &prvi, &drugi);
		//printf ("idsl: %d\n", this->redniBroj);
		//printf ("poce: %d %d %d %d \n", it->x, it->y, it->sirina, it->dubina);		
		//printf ("obje: %d %d %d %d \n", obj->x, obj->y, obj->sirina, obj->dubina);
		//printf("002\n");
		slobodni.erase(it);
		//printf("003\n");
		objekti.push_front(*obj);
		
		int p = this->uvjeti->sirina * this->dubina;
		//printf("004 %f\n", this->mjera_ispunjavanja);		
		this->mjera_ispunjavanja = (this->mjera_ispunjavanja * p + obj->sirina*obj->dubina)/((float)p); 		
		//printf("005 %f\n", this->mjera_ispunjavanja);
		if (prvi != NULL)
			slobodni.push_back(*prvi);
		//printf("005\n");
		if (drugi != NULL)
			slobodni.push_back(*drugi);

		it = slobodni.begin();
		//for (;it != slobodni.end(); it++) {
		//	printf ("	slob: %d %d %d %d %d \n", this->redniBroj, it->x, it->y, it->sirina, it->dubina);
		//	}
		//printf("\n");

		return true;
		}
	//printf("005\n");	
	return false;	
	}
